import sys
import paramiko
import json
import configparser
import os
import subprocess
sys.path.append('../')
from common.runlogger import *


def runTest(test_id,log_dir,dir):
    resultfile = open(log_dir+'/.result', 'w')
    testresult = False
    with open(dir+'runlist.json') as json_data:
        data = json.load(json_data)
        for i in range(len(data['environment']['hosts'])):
            result = False
            esx_host = getenvdata(dir,'esx','hostname')[i]
            esx_user= getenvdata(dir,'esx','user')[i]
            esx_password = getenvdata(dir,'esx','password')[i]
            try:
                ssh = sshConnection(esx_host,esx_user,esx_password)
                logging.info("Connected to host "+esx_host)
                command = "vm-support"
                stdin, stdout, stderr = ssh.exec_command(command,get_pty=True)
                logging.info("executing vm-support collection on host "+esx_host)
                if stderr.readline() == '':
                    while True:
                        nextline1 = stdout.readline()
                        logging.info(nextline1)
                        if nextline1 == '':
                            break        
                        if 'To see the files collected' in nextline1:
                            logs_host = nextline1[35:-1]
                            logs_host_dir = logs_host.strip()
                            logs_vmsupport = logs_host_dir[:-1]
                            logging.info("Logs at host are located at : "+logs_host_dir)
                            logging.info("Start Copying the "+logs_vmsupport+" from "+esx_host+" to local\n")
                            sftp = ssh.open_sftp()
                            sftp.get(logs_vmsupport, log_dir+"/../../vm-support-"+esx_host+".tgz")
                            sftp.close()
                            logging.info("Copying of vm-support logs from "+esx_host+" to local is successful \n")
                            result = True
                    if result == False:
                        logging.error("VM-support log collection failed for "+esx_host)
                        break
                else:
                    result = False
                    while True:
                        nextline1 = stderr.readline()
                        logging.info(nextline1)
                        if nextline1 == '':
                            break
                    break
            except Exception as e:
                logging.error("vm-support command failed "+str(e))
                result = False
                break
    if result:
        logging.info("Test PASSED")
        resultfile.write("Passed")
    else:
        logging.error("Test FAILED")
        resultfile.write("Failed")

def sshConnection(esx_host,esx_user,esx_password):
    ssh = paramiko.SSHClient()
    ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
    ssh.connect(hostname=esx_host, username=esx_user, password=esx_password)
    return ssh
    
def getenvdata(dir, hosttype,key):
      with open(dir+'runlist.json') as json_data:
          data = json.load(json_data)
          return  [ li[key] for li in data['environment']['hosts'] if li['hosttype'] == hosttype]

def main():
    runlogger(sys.argv[2])
    runTest(sys.argv[1],sys.argv[2],'/')
    
if __name__== '__main__':
    main()
